<?php

namespace dgsoft\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StreetNmbrType StructType
 * @package Dg
 * @subpackage Structs
 */
class DgStreetNmbrType extends AbstractStructBase
{
    /**
     * The _
     * @var string
     */
    public $_;
    /**
     * The PO_Box
     * @var string
     */
    public $PO_Box;
    /**
     * Constructor method for StreetNmbrType
     * @uses DgStreetNmbrType::set_()
     * @uses DgStreetNmbrType::setPO_Box()
     * @param string $_
     * @param string $pO_Box
     */
    public function __construct($_ = null, $pO_Box = null)
    {
        $this
            ->set_($_)
            ->setPO_Box($pO_Box);
    }
    /**
     * Get _ value
     * @return string|null
     */
    public function get_()
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @param string $_
     * @return \dgsoft\StructType\DgStreetNmbrType
     */
    public function set_($_ = null)
    {
        // validation for constraint: string
        if (!is_null($_) && !is_string($_)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($_)), __LINE__);
        }
        $this->_ = $_;
        return $this;
    }
    /**
     * Get PO_Box value
     * @return string|null
     */
    public function getPO_Box()
    {
        return $this->PO_Box;
    }
    /**
     * Set PO_Box value
     * @param string $pO_Box
     * @return \dgsoft\StructType\DgStreetNmbrType
     */
    public function setPO_Box($pO_Box = null)
    {
        // validation for constraint: string
        if (!is_null($pO_Box) && !is_string($pO_Box)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($pO_Box)), __LINE__);
        }
        $this->PO_Box = $pO_Box;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\StructType\DgStreetNmbrType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
